{$R+}
{$S+}
{$M 65520,0,655360}
PROGRAM  EDITECR; { 1995 Frantz Degrigny }
{ Editeur de clipart 320x240 pixels 16 couleurs pour pc  }

USES CRT,GRAPH,DOS,Souris,Graf16;

TYPE
  Chaine11 = STRING[11];
  Chaine50 = STRING[50];
  Tmax     = Longint;
  t_Image  = ARRAY[1..Tmax(48002)] OF BYTE;

VAR
  ligne,colonne,bouton       : WORD;
  crayon,fond,g_police       : WORD;
  size                       : WORD;
  g_taille                   : INTEGER;
  g_fini                     : BOOLEAN;
  g_pressPapier              : POINTER;
  g_ppSize,g_lar,g_long      : INTEGER;
  g_image                    : pointer;
  ch : string;
  g_fichier :file;


{****************************************************************************}

PROCEDURE Initgraphiques;
  VAR
    Graphmode       : INTEGER;
    Graphpilot      : INTEGER;
    ModeInf,ModeSup : INTEGER;

  BEGIN
    Graphpilot:=Detect;
    InitGraph (Graphpilot,Graphmode,'');
    IF GraphResult = -3
       THEN
         BEGIN
           Clrscr;
           Writeln ('EGAVGA.BGI doit tre prsent dans le rpertoire de lancement');
           Halt;
         END;
    GetModeRange(GraphPilot,ModeInf,modeSup);
    SetGraphMode(ModeSup);
    SetRGBpalette(6,63,39,0);
    Setpalette(6,6);
    SetRGBpalette(8,35,35,35);
    Setpalette(8,8);
    SetRGBpalette(3,63,57,57);
    Setpalette(3,3);
    SetBkColor(0);
    SetColor (6);
  END;

{****************************************************************************}

PROCEDURE ColorieRectangle(x,y,x2,y2 : INTEGER;Couleur : WORD);
VAR
 long,i :INTEGER;

BEGIN
long:=(x2-x);
Setcolor(Couleur);
FOR i:=0 TO long DO
 LINE(x+i,y,x+i,y2);
END;

{****************************************************************************}

PROCEDURE ReadStringXY (X,Y :INTEGER;VAR chaine : chaine50;ecriture,papier : WORD);
VAR
  Touche : CHAR;
BEGIN
  OutTextXY(X,Y,chaine);
  REPEAT
    touche :=readkey;
    IF touche <> #13
       THEN
         BEGIN
           IF touche = #08
              THEN
                BEGIN
                  SetColor (papier);
                  OutTextXY(X,Y,chaine);
                  delete(chaine,length(chaine),1);
                  Setcolor (ecriture);
                  OutTextXY(X,Y,chaine);
                END
              ELSE
                BEGIN
                  Chaine := concat(chaine,touche);
                  OutTextXY (X,Y,chaine);
                END;
         END;
    UNTIL touche = #13;
  END;

{****************************************************************************}

PROCEDURE InitSouris;
VAR
  Touche : CHAR;

BEGIN
 IF testsouris
THEN
 Montrecurseur
ELSE
 BEGIN
  OutTextxy(200,400,'la souris n''est pas detecte');
  touche:=readkey;
 END;
END;

{****************************************************************************}

PROCEDURE Sauvegarde(x1,y1,x2,y2 : INTEGER);
  VAR
    fichier             : FILE ;
    chaine              : Chaine50;
    nomfichier,ch       : Chaine11;
    l_image             : POINTER;

 BEGIN
   Cachecurseur;
   ColorieRectangle(95,95,460,120,15);
   SetColor(9);
   Rectangle(95,95,460,120);
   Getmem(l_image,imageSize(x1,y1,x2,y2));
   Getimage(x1,y1,x2,y2,l_image^);
   SetTextStyle(DefaultFont,Horizdir,1);
   OutTextXY (100,100,'Donnez le nom du fichier a Sauver : ');
   Chaine:='';
   ReadStringXY (390,100,chaine,9,15);
   Nomfichier := copy (chaine,1,11);
   Assign (Fichier,nomfichier+'.ECR');
   IF NOT (Nomfichier='')
   THEN
    BEGIN
     Rewrite (Fichier,1);
     BlockWrite(fichier,l_image^,imageSize(x1,y1,x2,y2));
     Close (Fichier);
    END;
   Freemem(l_image,imageSize(x1,y1,x2,y2));
   ColorieRectangle(95,95,460,120,2);
   MontreCurseur;
   SetTextStyle(TriplexFont,Horizdir,4);
 END;

{****************************************************************************}

PROCEDURE Charge;

 TYPE
    t_tab             = ARRAY[1..9] OF STRING[12];
 VAR
   fichier            : FILE ;
   p_image            : POINTER;
   chaine             : Chaine50;
   nomfichier         : Chaine11;
   touche             : CHAR;
   code               : WORD;
   tab                : t_tab;
   Attributs          : SearchRec;
   n_total,I,n        : INTEGER;
   l_ligne,l_colonne,
   l_bouton           : WORD;
   Choisi,OK,Annuler  : BOOLEAN;
   P                  : POINTER;
   page,PageMax       : LONGINT;


BEGIN
  Page:=1;
  FOR I:= 1 TO 9 DO
   Tab[I]:='            ';
  Annuler:=false;
  OK:=false;
  FindFirst('*.ECR', Archive,Attributs);
  n_total:=0;
  WHILE DosError = 0 DO
  BEGIN
    FindNext(Attributs);
    n_total:=n_total+1;
  END;
  PageMax:=(n_total DIV 9);
  IF (n_total MOD 9)<>0 THEN PageMax:=PageMax+1;
  I:=0;
  FindFirst('*.ECR', Archive,Attributs);
  REPEAT
   I:=I+1;
   tab[I]:=Attributs.name;
   FindNext(Attributs);
  UNTIL (I=9) OR (I=n_total);
  GetMem(p,Imagesize(95,80,300,320));
  CacheCurseur;
  Getimage(95,80,300,320,p^);
  MontreCurseur;
 REPEAT
  CacheCurseur;
  Choisi:=false;
  Setcolor(9);
  SetTextStyle(DefaultFont,Horizdir,1);
  ColorieRectangle(95,80,300,320,15);
  Setcolor(9);
  Rectangle(95,80,300,320);
  Rectangle(115,120,240,305);
  Rectangle(115,90,240,110);
  Rectangle(250,90,292,110);
  OutTextxy(262,97,'OK');
  Rectangle(250,120,292,140);
  SetTextStyle(SmallFont,Horizdir,4);
  OutTextxy(252,125,'Annuler');
  IF NOT (page=PageMax)
   THEN
    BEGIN
     SetTextStyle(SmallFont,1,5);
     Rectangle(250,285,270,305);
     OutTextxy(254,285,'<<');
     SetTextStyle(DefaultFont,Horizdir,1);
    END;
  SetTextStyle(DefaultFont,Horizdir,1);
  FOR I:= 0 TO 8 DO
    OutTextxy(125,130+I*20,Tab[1+I]);
  MontreCurseur;
  n:=1;
  Chaine:='';
  REPEAT
   TrouvePosition(l_ligne,l_colonne,l_bouton);
    IF (l_bouton=1) and (l_colonne>250) and (l_ligne>90) and (l_colonne<292) and (l_ligne<110)
     THEN choisi:=true;
    IF (l_bouton=1) and (l_colonne>250) and (l_ligne>120) and (l_colonne<292) and (l_ligne<140)
     THEN Annuler:=true;
    IF (l_bouton=1) and (l_colonne>115) and (l_ligne>90) and (l_colonne<240) and (l_ligne<110)
     THEN
      BEGIN
       Setcolor(9);
       CacheCurseur;
       ReadStringXY(125,98,Chaine,9,15);
       MontreCurseur;
       choisi:=true;
      END;
    IF (l_bouton=1) and (l_colonne>115) and (l_ligne>120) and (l_colonne<240) and (l_ligne<305)
     THEN
      BEGIN
       Setcolor(15);
       CacheCurseur;
       Rectangle(120,105+n*20,235,120+n*20);
       OutTextxy(125,98,chaine);
       MontreCurseur;
       n:=(l_ligne-100) DIV 20;
       chaine:=tab[n];
       Setcolor(9);
       chaine:=copy(chaine,1,length(chaine)-4);
       CacheCurseur;
       OutTextxy(125,98,chaine);
       MontreCurseur;
       setcolor(12);
       CacheCurseur;
       Rectangle(120,105+n*20,235,120+n*20);
       MontreCurseur;
      END;
  IF NOT (page=Pagemax) and (l_bouton=1) and
         (l_colonne>250) and (l_ligne>285) and (l_colonne<270) and (l_ligne<305)
    THEN
     BEGIN
      I:=0;
      FindFirst('*.ECR',Archive,Attributs);
      REPEAT
       I:=I+1;
       FindNext(Attributs);
      UNTIL I=page*9;
      FOR I:= 1 TO 9 DO
       Tab[I]:='            ';
      I:=0;
      REPEAT
       I:=I+1;
       tab[I]:=Attributs.name;
       FindNext(Attributs);
      UNTIL (I=9) OR (I=(n_total-((page)*9)));
      SetTextStyle(DefaultFont,Horizdir,1);
      CacheCurseur;
      ColorieRectangle(116,121,239,304,15);
      Setcolor(9);
      FOR I:= 0 TO 8 DO
       OutTextxy(125,130+I*20,Tab[1+I]);
      MontreCurseur;
      Page:=page+1;
      SetTextStyle(SmallFont,1,5);
      CacheCurseur;
      Rectangle(250,255,270,275);
      OutTextxy(254,256,'>>');
      IF (Page=PageMax) THEN colorieRectangle(250,285,270,305,15);
      MontreCurseur;
      SetTextstyle(0,0,1);
     END;
  IF NOT (page=1) and (l_bouton=1) and
         (l_colonne>250) and (l_ligne>255) and (l_colonne<270) and (l_ligne<275)
    THEN
     BEGIN
      I:=0;
      FindFirst('*.ECR',Archive,Attributs);
      WHILE (I<(page-2)*9) DO
       BEGIN
        I:=I+1;
        FindNext(attributs);
       END;
      I:=0;
      REPEAT
       I:=I+1;
       tab[I]:=Attributs.name;
       FindNext(Attributs);
      UNTIL (I=9);
      SetTextStyle(DefaultFont,Horizdir,1);
      CacheCurseur;
      ColorieRectangle(116,121,239,304,15);
      Setcolor(9);
      FOR I:= 0 TO 8 DO
       OutTextxy(125,130+I*20,Tab[1+I]);
      MontreCurseur;
      page:=page-1;
      SetTextStyle(SmallFont,1,5);
      CacheCurseur;
      Rectangle(250,285,270,305);
      OutTextxy(254,285,'<<');
      IF (Page=1) THEN colorieRectangle(250,255,270,275,15);
      MontreCurseur;
      SetTextstyle(0,0,1);
     END;
  UNTIL Choisi OR Annuler;
  IF NOT Annuler
   THEN
    BEGIN
     Nomfichier:=chaine;
     {$I-}
     Assign (Fichier,nomfichier+'.ECR');
     RESET(Fichier,1);
     {$I+}
        IF IORESULT <> 0
          THEN
             BEGIN
               CacheCurseur;
               ColorieRectangle(100,195,295,235,14);
               setcolor(0);
               Rectangle(100,195,295,235);
               OutTextxy(105,200,'Ce fichier n''existe pas');
               OutTextxy(102,220,'   dans ce rpertoire');
               MontreCurseur;
               touche:=readkey;
               Setcolor(9);
             END
          ELSE
           BEGIN
            CacheCurseur;
            PutImage(95,80,p^,normalput);
            MontreCurseur;
            FreeMem(p,Imagesize(95,80,300,320));
            GetMem(p_image,Filesize(Fichier));
            Blockread(fichier,p_image^,Filesize(Fichier));
            CacheCurseur;
            PutImage(190,180,p_image^,NormalPut);
            MontreCurseur;
            Freemem(p_image,Filesize(Fichier));
            Close (Fichier);
            OK:=true;
          END;
    END;
UNTIL OK OR Annuler;
IF Annuler THEN
 BEGIN
  CacheCurseur;
  PutImage(95,80,p^,normalput);
  MontreCurseur;
  FreeMem(p,Imagesize(95,80,300,320));
 END;
SetTextStyle(TriplexFont,Horizdir,4);
END;

{****************************************************************************}

PROCEDURE AfficheMatrice(x,y : INTEGER; VAR p_image : t_image);
VAR
 i,j : longint;
 Xmax,Ymax : BYTE;

BEGIN
 Xmax:=p_image[1];
 Ymax:=p_image[2];
 CacheCurseur;
 FOR J:= 1 TO Ymax DO
  FOR I:= 1 TO Xmax DO
    IF NOT (p_image[2+I+(J-1)*Xmax]=17)
     THEN putpixel16(i+x,j+y,p_image[2+I+(J-1)*Xmax],pRep);
 MontreCurseur;
END;

{****************************************************************************}

PROCEDURE Croix(x,y,x2,y2 : INTEGER;Couleur : WORD);

BEGIN
Setcolor(Couleur);
LINE(x,y,x2,y2);
LINE(x,y2,x2,y);
END;

{****************************************************************************}

PROCEDURE Segment(x,y : INTEGER; Long : INTEGER; Angle1 : INTEGER);
VAR
 x1,y1    : REAL;
 x2,y2    : INTEGER;
 AngleRad : REAL;

BEGIN
AngleRad:=((angle1*Pi)/180);
IF (Angle1=0) OR (Angle1=180) OR (Angle1=270) OR (Angle1=90)
THEN
 BEGIN
  CASE Angle1 OF 90 :BEGIN
                     x2:=X;
                     y2:=y-long;
                    END;
               270 :BEGIN
                     x2:=X;
                     y2:=y+long;
                    END;
                0 :BEGIN
                     x2:=X+long;
                     y2:=y;
                    END;
              180 :BEGIN
                     x2:=X-long;
                     y2:=y;
                    END;
  END;
  Line(x,y,x2,y2);
 END
ELSE
 BEGIN
  x1:=(long*(cos(angleRad)));
  y1:=(long*(sin(angleRad)));
  x2:=(round(x1));
  y2:=(round(y1));
  Line(x,y,x+x2,y-y2);
 END;
END;

{****************************************************************************}

PROCEDURE DessineFontEcran;
VAR
  I,J     : INTEGER;
  coul    : WORD;
  l_icone : t_image;
  size     :integer;
  p        :pointer;

{ * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}

PROCEDURE Rappel(VAR p_image : t_image ; Nomfichier : Chaine11);
 VAR
   fichier            : FILE;
   chaine             : Chaine11;
   Fch                : STRING;
   touche             : CHAR;
   code               : WORD;

 BEGIN
  Setcolor(9);
  {$I-}
  Assign (Fichier,nomfichier+'.CDS');
    RESET(Fichier);
     IF IORESULT <> 0
       THEN
          BEGIN
            Fch:='le fichier .CDS est introuvable dans le repertoire de lancement';
            Insert(NomFichier,Fch,12);
            OutTextxy(100,80,Fch);
            touche:=readkey;
            ColorieRectangle(100,80,400,100,2);
          END
       ELSE
         BEGIN
         Blockread(fichier,p_image,sizeof(p_image),code);
         END;
     Close (Fichier);
     {$I+}
 END;

{ * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}

PROCEDURE AfficheIcone(VAR p_image : t_image; X,Y : INTEGER );
VAR
 i,j       : longint;
 Xmax,Ymax : BYTE;

BEGIN
 Xmax:=p_image[1];
 Ymax:=p_image[2];
 FOR J:= 1 TO Ymax DO
  FOR I:= 1 TO Xmax DO
     putpixel16(i+X,j+Y,p_image[2+I+(J-1)*Xmax],pRep);
END;

{ * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}

BEGIN{ *** DessineFontEcran ***}
 Setcolor(9);
 SetTextStyle(Triplexfont,horizdir,1);
 OutTextxy(110,2,'<    <   <  < << EDITECR >> >  >   >    >');
 Rectangle(0,30,639,479);
 Line(0,50,639,50);
 SetfillStyle(1,2);
 FloodFill(150,100,9);
 SetfillStyle(1,15);
 FloodFill(100,45,9);
 FOR i:=0 TO 3 DO
   BEGIN
    Rectangle(20,140+80*i,180,220+80*i);
    FloodFill(100,160+(80*I),9);
   END;
 Line(100,420,180,420);
 Line(100,140,100,460);
 Setcolor(12);
 Line(115,155,170,210);
 ColorieRectangle(189,179,511,421,15);
 Setcolor(9);
 Rectangle(188,178,512,422);
 { rectangle & cercle evides : }
  Setcolor(10);
  Rectangle(35,240,85,280);
  Circle(140,260,25);
 { rectangle & cerle pleins : }
  ColorieRectangle(35,320,85,360,6);
  SetFillStyle(1,6);
  Setcolor(6);
  Circle(140,340,25);
  FloodFill(140,340,6);
  SetColor(9);
 FOR I:=0 TO 7 DO
   Rectangle(560,180+30*I,620,210+I*30);
 Line(590,180,590,420);
 coul:=0;
 FOR I:=0 TO 1 DO
  FOR J:=0 TO 7 DO
   BEGIN
    SetFillStyle(1,coul);
    INC(coul);
    FloodFill(580+I*30,190+j*30,9);
   END;
 Setcolor(9);
 Rectangle(560,430,620,470);
 FloodFill(580,440,9);
 Rectangle(570,440,610,460);
 { crayon : }
 Rappel(l_icone,'ico3');
 AfficheIcone(l_icone,50,140);
 { les 3 dernieres }
 Rappel(l_icone,'ico2');
 AfficheIcone(l_icone,122,390);
 SetTextStyle(TriplexFont,HorizDir,1);
 OutTextXY(118,427,'A B C');
 Rappel(l_icone,'ico1');
 AfficheIcone(l_icone,22,400);
 SetFillStyle(1,2);
 FloodFill(300,450,9);
 { fonctions : }
 SetTextStyle(DefaultFont,HorizDir,1);
 OutTextxy(175,35,'Zoom');
 OutTextxy(90,35,'Effacer');
 OutTextxy(10,35,'Fichier');
 OutTextxy(240,35,'Edit');
 OutTextxy(310,35,'Police');
 OutTextxy(380,35,'Image');
 OutTextxy(450,35,'Taille');
 SetTextStyle(TriplexFont,HorizDir,4);
END;

{****************************************************************************}

PROCEDURE Coordonnees(VAR l_ligne,l_colonne,l_ligne1,l_colonne1 : WORD);
VAR
Chl,ChC            : STRING;

BEGIN
 IF (l_ligne<>l_ligne1) OR (l_colonne<>l_colonne1)
  THEN
   BEGIN
     Setcolor(15);
     SetTextStyle(smallfont,horizdir,6);
     str((l_ligne1-180),ChL);
     str((l_colonne1-190),ChC);
     CacheCurseur;
     OutTextxy(300,450,ChC);
     OutTextxy(350,450,ChL);
     MontreCurseur;
     Setcolor(9);
     str((l_ligne-180),ChL);
     str((l_colonne-190),ChC);
     CacheCurseur;
     OutTextxy(300,450,ChC);
     OutTextxy(350,450,ChL);
     MontreCurseur;
     l_ligne1:=l_ligne;
     l_colonne1:=l_colonne;
   END;
END;

{****************************************************************************}

PROCEDURE traceLigne(p_crayon : WORD);
VAR
 l_colonne,l_ligne,l_bouton,
 l_colonne1,l_ligne1        : WORD;
 X1,Y1,X3,Y3 : INTEGER;
 p           : POINTER;
 point1,fini : BOOLEAN;
 size        : WORD;
 CoefL,CoefC : INTEGER;
 Chl,ChC,l_Long,l_long1: STRING;


BEGIN
point1:=false;
fini:=false;
Setcolor(9);
CacheCurseur;
OutTextxy(160,140,'*');
colorieRectangle(280,445,430,470,15);
Setcolor(9);
Rectangle(280,445,430,470);
SetTextStyle(smallfont,horizdir,6);
OutTextxy(285,450,'X:');
OutTextxy(335,450,'Y:');
MontreCurseur;
l_ligne1:=180;
l_colonne1:=190;
REPEAT
Trouveposition(l_ligne,l_colonne,l_bouton);
 IF (l_ligne>179) and (l_ligne<421) and (l_colonne>189) and (l_colonne<511)
  THEN
   BEGIN
    Coordonnees(l_ligne,l_colonne,l_ligne1,l_colonne1);
IF (l_bouton=1)
THEN
  BEGIN
   X1:=l_colonne;
   Y1:=l_ligne;
   point1:=true;
  END;
IF (point1=true)
 THEN
   WHILE (fini=false) DO
    BEGIN
     Trouveposition(l_ligne,l_colonne,l_bouton);
     IF NOT ((l_ligne>179) and (l_ligne<421) and (l_colonne>189) and (l_colonne<511))
     THEN
      BEGIN
      IF l_ligne<180 THEN l_ligne:=180;
      IF l_ligne>420 THEN l_ligne:=420;
      IF l_colonne<190 THEN l_colonne:=190;
      IF l_colonne>510 THEN l_colonne:=510;
      CacheCurseur;
      PlaceSouris(l_ligne,l_colonne);
      MontreCurseur;
     END;
     IF l_colonne>=X1
      THEN
       IF l_ligne>=Y1
        THEN
         BEGIN
          X3:=X1-1;
          Y3:=Y1-1;
          CoefL:=-1;
          CoefC:=-1;
         END
        ELSE
         BEGIN
          X3:=X1-1;
          Y3:=l_ligne-1;
          CoefL:=1;
          CoefC:=-1;
         END
      ELSE
       IF l_ligne>=Y1
        THEN
         BEGIN
          X3:=l_colonne-1;
          Y3:=Y1-1;
          CoefL:=-1;
          CoefC:=1;
         END
        ELSE
         BEGIN
          X3:=l_colonne-1;
          Y3:=l_ligne-1;
          CoefL:=1;
          CoefC:=1;
         END;
     Size := ImageSize(X1+CoefC,Y1+CoefL,l_colonne-CoefC,l_ligne-CoefL);
     GetMem(P, Size);
     SetColor(p_crayon);
     CacheCurseur;
     GetImage(X1+CoefC,Y1+CoefL,l_colonne-CoefC,l_ligne-CoefL,P^);
     line(x1,y1,l_colonne,l_ligne);
     delay(60);
     PutImage(X3,Y3, P^, NormalPut);
     montrecurseur;
     FreeMem(p,Size);
     SetColor(9);
     OutTextxy(385,450,'L:');
   IF  (l_ligne1<>l_ligne) OR (l_colonne1<>l_colonne) THEN
    BEGIN
     Setcolor(15);
     SetTextStyle(smallfont,horizdir,6);
     str((l_ligne1-180),ChL);
     str((l_colonne1-190),ChC);
     CacheCurseur;
     OutTextxy(300,450,ChC);
     OutTextxy(350,450,ChL);
     OutTextxy(400,450,l_Long1);
     MontreCurseur;
     Setcolor(9);
     str((l_ligne-180),ChL);
     str((l_colonne-190),ChC);
     str( (Round (sqrt (sqr (abs(Y1-l_ligne))+sqr(Abs(X1-l_colonne)) ) )  ),l_Long);
     CacheCurseur;
     OutTextxy(300,450,ChC);
     OutTextxy(350,450,ChL);
     OutTextxy(400,450,l_Long);
     MontreCurseur;
     l_ligne1:=l_ligne;
     l_colonne1:=l_colonne;
     l_long1:=l_long;
 END;
     IF l_bouton=2 THEN
      BEGIN
       fini:=true;
       SetColor(p_crayon);
       cacheCurseur;
       line(x1,y1,l_colonne,l_ligne);
       MontreCurseur;
      END;
    END;
END;
UNTIL fini;
SetColor(15);
SetTextStyle(triplexfont,Horizdir,4);
OutTextxy(160,140,'*');
colorieRectangle(280,445,430,470,2);
END;

{****************************************************************************}

PROCEDURE TraceRectangle(p_crayon: WORD; sorte : BYTE);
VAR
 l_colonne,l_ligne,l_bouton,
 l_colonne1,l_ligne1  : WORD;
 X1,Y1,X3,Y3          : INTEGER;
 p                    : POINTER;
 point1,fini          : BOOLEAN;
 size                 : WORD;
 CoefL,CoefC          : INTEGER;
 Chl,ChC              : STRING;

BEGIN
point1:=false;
fini:=false;
Setcolor(9);
CacheCurseur;
IF sorte=1
 THEN OutTextxy(80,220,'*')
 ELSE OutTextxy(80,300,'*');
colorieRectangle(280,445,380,470,15);
Setcolor(9);
Rectangle(280,445,380,470);
SetTextStyle(smallfont,horizdir,6);
OutTextxy(285,450,'X:');
OutTextxy(335,450,'Y:');
l_colonne1:=190;
l_ligne1:=180;
MontreCurseur;
WHILE NOT fini DO
BEGIN
Trouveposition(l_ligne,l_colonne,l_bouton);
 IF (l_ligne>179) and (l_ligne<421) and (l_colonne>189) and (l_colonne<511)
  THEN
   BEGIN
   Coordonnees(l_ligne,l_colonne,l_ligne1,l_colonne1);
IF (l_bouton=1)
THEN
  BEGIN
   X1:= l_colonne;
   Y1:= l_ligne;
   point1:=true;
  END;
IF (point1=true)
 THEN
   WHILE (fini=false) DO
    BEGIN
     Trouveposition(l_ligne,l_colonne,l_bouton);
     IF NOT ((l_ligne>179) and (l_ligne<421) and (l_colonne>189) and (l_colonne<511))
     THEN
      BEGIN
      IF l_ligne<180 THEN l_ligne:=180;
      IF l_ligne>420 THEN l_ligne:=420;
      IF l_colonne<190 THEN l_colonne:=190;
      IF l_colonne>510  THEN l_colonne:=510;
      CacheCurseur;
      PlaceSouris(l_ligne,l_colonne);
      MontreCurseur;
     END;
     IF l_colonne>=X1
      THEN
       IF l_ligne>=Y1
        THEN
         BEGIN
          X3:=X1-1;
          Y3:=Y1-1;
          CoefL:=-1;
          CoefC:=-1;
         END
        ELSE
         BEGIN
          X3:=X1-1;
          Y3:=l_ligne-1;
          CoefL:=1;
          CoefC:=-1;
         END
      ELSE
       IF l_ligne>=Y1
        THEN
         BEGIN
          X3:=l_colonne-1;
          Y3:=Y1-1;
          CoefL:=-1;
          CoefC:=1;
         END
        ELSE
         BEGIN
          X3:=l_colonne-1;
          Y3:=l_ligne-1;
          CoefL:=1;
          CoefC:=1;
         END;
     Size := ImageSize(X1+CoefC,Y1+CoefL,l_colonne-CoefC,l_ligne-CoefL);
     GetMem(P, Size);
     SetColor(p_crayon);
     CacheCurseur;
     GetImage(X1+CoefC,Y1+CoefL,l_colonne-CoefC,l_ligne-CoefL,P^);
     Rectangle(X1,y1,l_colonne,l_ligne);
     delay(60);
     PutImage(X3,Y3, P^, NormalPut);
     montrecurseur;
     FreeMem(p,Size);
     Coordonnees(l_ligne,l_colonne,l_ligne1,l_colonne1);
     IF l_bouton=2 THEN
      BEGIN
       fini:=true;
       SetColor(p_crayon);
       cacheCurseur;
       IF sorte=1
        THEN Rectangle(x1,y1,l_colonne,l_ligne)
        ELSE BEGIN
              IF (l_colonne>=x1)
               THEN
                ColorieRectangle(x1,y1,l_colonne,l_ligne,p_crayon)
               ELSE
                ColorieRectangle(l_colonne,l_ligne,x1,y1,p_crayon);
             END;
       MontreCurseur;
      END;
    END;
END;
END;
SetColor(15);
SetTextStyle(triplexfont,Horizdir,4);
IF sorte=1
 THEN OutTextxy(80,220,'*')
 ELSE OutTextxy(80,300,'*');
colorieRectangle(280,445,380,470,2);
END;

{****************************************************************************}

FUNCTION tropGrand(p_X1,p_Y1,p_rayon : INTEGER) : BOOLEAN;
 BEGIN
  IF (p_X1-p_rayon<190) or (p_X1+p_rayon>510) or (p_Y1-p_rayon<180) or (p_Y1+p_rayon>420)
   THEN tropGrand:=true
   ELSE tropGrand:=false;
 END;

{****************************************************************************}

PROCEDURE Cercle(p_crayon : WORD; sorte : BYTE);
VAR
 l_colonne,l_ligne,l_bouton,
 l_colonne1,l_ligne1    : WORD;
 X1,Y1                  : INTEGER;
 p                      : POINTER;
 point1,fini            : BOOLEAN;
 size                   : WORD;
 rayon,I                : INTEGER;
 Chl,ChC                : STRING;

BEGIN
point1:=false;
fini:=false;
Setcolor(9);
CacheCurseur;
IF sorte=1
 THEN OutTextxy(160,220,'*')
 ELSE OutTextxy(160,300,'*');
colorieRectangle(280,445,380,470,15);
Setcolor(9);
Rectangle(280,445,380,470);
SetTextStyle(smallfont,horizdir,6);
OutTextxy(285,450,'X:');
OutTextxy(335,450,'Y:');
MontreCurseur;
l_colonne1:=190;
l_ligne1:=180;
REPEAT
Trouveposition(l_ligne,l_colonne,l_bouton);
IF (l_ligne>179) and (l_ligne<421) and (l_colonne>189) and (l_colonne<511)
  THEN
   BEGIN
    Coordonnees(l_ligne,l_colonne,l_ligne1,l_colonne1);
IF (l_bouton=1)
THEN
  BEGIN
   X1:= l_colonne;
   Y1:= l_ligne;
   point1:=true;
  END;
IF (point1=true)
 THEN
   WHILE (fini=false) DO
    BEGIN
     Trouveposition(l_ligne,l_colonne,l_bouton);
     IF NOT ((l_ligne>179) and (l_ligne<421) and (l_colonne>189) and (l_colonne<511))
     THEN
      BEGIN
      IF l_ligne<180 THEN l_ligne:=180;
      IF l_ligne>420 THEN l_ligne:=420;
      IF l_colonne<190 THEN l_colonne:=190;
      IF l_colonne>510  THEN l_colonne:=510;
      CacheCurseur;
      PlaceSouris(l_ligne,l_colonne);
      MontreCurseur;
     END;
     Rayon:=(Round (sqrt (sqr (abs(Y1-l_ligne))+sqr(Abs(X1-l_colonne)) ) )  );
     IF NOT tropGrand (x1,y1,rayon) THEN
      BEGIN
       Size := ImageSize(X1+Rayon+1,Y1+rayon+1,X1-Rayon-1,Y1-rayon-1);
       GetMem(P, Size);
       SetColor(p_crayon);
       CacheCurseur;
       GetImage(X1+Rayon+1,Y1+rayon+1,X1-Rayon-1,Y1-rayon-1,P^);
       Circle(X1,y1,Rayon);
       delay(60);
       PutImage(X1-Rayon-1,Y1-rayon-1, P^, NormalPut);
       montrecurseur;
       FreeMem(p,Size);
   Coordonnees(l_ligne,l_colonne,l_ligne1,l_colonne1);
     IF l_bouton=2 THEN
      BEGIN
       fini:=true;
       SetColor(p_crayon);
       cacheCurseur;
       IF sorte=1
        THEN Circle(X1,y1,Rayon)
        ELSE BEGIN
              Circle(X1,y1,rayon);
              SetFillStyle(1,crayon);
               FloodFill(x1,y1,crayon);
              FOR I:= 1 TO (Rayon-1) DO
               Circle(X1,y1,I);
              FOR I:= 0 TO 359 DO
               Segment(X1,y1,rayon,I);
              SetFillStyle(1,crayon);
              FloodFill(x1,y1,crayon);
             END;
       MontreCurseur;
      END;
     END;
    END;
END;
UNTIL fini;
SetColor(15);
SetTextStyle(triplexfont,Horizdir,4);
CacheCurseur;
IF sorte=1
 THEN OutTextxy(160,220,'*')
 ELSE OutTextxy(160,300,'*');
colorieRectangle(280,445,380,470,2);
MontreCurseur;
END;

{****************************************************************************}

PROCEDURE Pinceau(p_crayon : Word);
VAR
 l_colonne,l_ligne,l_bouton,
 l_colonne1,l_ligne1 : WORD;
 Chl,ChC: STRING;

BEGIN
Setcolor(9);
CacheCurseur;
OutTextxy(80,140,'*');
colorieRectangle(280,445,380,470,15);
Setcolor(9);
Rectangle(280,445,380,470);
SetTextStyle(smallfont,horizdir,6);
OutTextxy(285,450,'X:');
OutTextxy(335,450,'Y:');
MontreCurseur;
l_colonne1:=190;
l_ligne1:=180;
REPEAT
Trouveposition(l_ligne,l_colonne,l_bouton);
IF (l_ligne>179) and (l_ligne<421) and (l_colonne>189) and (l_colonne<511)
 THEN
   BEGIN
     Coordonnees(l_ligne,l_colonne,l_ligne1,l_colonne1);
     IF (l_bouton=1) THEN
      BEGIN
       Cachecurseur;
       putpixel16(l_colonne,l_ligne,p_crayon,pRep);
       MontreCurseur;
      END;
   END;
UNTIL ((l_bouton=1) OR (l_bouton=2)) and
      NOT((l_ligne>179) and (l_ligne<421) and (l_colonne>189) and (l_colonne<511));
Setcolor(15);
SetTextStyle(triplexfont,HorizDir,4);
CacheCurseur;
OutTextxy(80,140,'*');
colorieRectangle(280,445,380,470,2);
Montrecurseur;
END;

{****************************************************************************}

PROCEDURE Peinture(p_crayon,p_fond : WORD);
VAR
   l_colonne,l_ligne,l_bouton  : WORD;
   l_fini                      : BOOLEAN;

BEGIN
l_fini:=false;
SetColor(9);
SetTextStyle(triplexfont,Horizdir,4);
CacheCurseur;
OutTextxy(80,380,'*');
MontreCurseur;
REPEAT
 Trouveposition(l_ligne,l_colonne,l_bouton);
IF (l_ligne>179) and (l_ligne<421) and (l_colonne>189) and (l_colonne<511)
  THEN
   BEGIN
    IF l_bouton=1 THEN
     BEGIN
      SetFillStyle(1,p_crayon);
      CacheCurseur;
      FloodFill(l_colonne,l_ligne,p_fond);
      MontreCurseur;
      l_fini:=true;
     END;
   END;
UNTIL l_fini;
SetColor(15);
OutTextxy(80,380,'*');
END;

{****************************************************************************}

PROCEDURE Gomme(p_fond : WORD);
VAR
   l_colonne,l_ligne,l_bouton  : WORD;
   P                           : POINTER;
   Size                        : INTEGER;

BEGIN
SetColor(9);
SetTextStyle(triplexfont,Horizdir,4);
CacheCurseur;
OutTextxy(160,380,'*');
MontreCurseur;
REPEAT
 Trouveposition(l_ligne,l_colonne,l_bouton);
 IF (l_ligne>179) and (l_ligne<397) and (l_colonne>189) and (l_colonne<491)
  THEN
   BEGIN
    CacheCurseur;
    Size := ImageSize(l_colonne+20,l_ligne+24,l_colonne,l_ligne);
    GetMem(P, Size);
    SetColor(0);
    GetImage(l_colonne+20,l_ligne+24,l_colonne,l_ligne,P^);
    Rectangle(l_colonne+20,l_ligne+24,l_colonne,l_ligne);
    delay(60);
    PutImage(l_colonne,l_ligne, P^, NormalPut);
    FreeMem(p,Size);
    IF l_bouton=1 THEN ColorieRectangle(l_colonne,l_ligne,l_colonne+20,l_ligne+24,p_fond);
    MontreCurseur;
   END;
UNTIL ((l_bouton=1) OR (l_bouton=2)) and
      NOT((l_ligne>179) and (l_ligne<421) and (l_colonne>189) and (l_colonne<491));
SetColor(15);
OutTextxy(160,380,'*');
MontreCurseur;
END;

{****************************************************************************}

PROCEDURE Texte(p_crayon,p_fond,p_police : WORD;p_taille : INTEGER);
VAR
   l_colonne,l_ligne,l_bouton  : WORD;
   l_fini                      : BOOLEAN;
   chaine                      : Chaine50;
   touche                      : CHAR;
   X1,Y1,Z                     : INTEGER;

BEGIN
l_fini:=false;
SetColor(12);
SetTextStyle(triplexfont,Horizdir,1);
CacheCurseur;
OutTextXY(118,427,'A B C');
MontreCurseur;
SetTextStyle(p_police,0,p_taille);
IF (p_police=4) OR (p_police=1)
 THEN IF p_taille<11
        THEN Z:=15+2*p_taille
        ELSE Z:=35;
IF p_police=2
 THEN IF p_taille<11
       THEN Z:=g_taille
       ELSE Z:=10;
IF p_police=0 THEN Z:=1;
REPEAT
Trouveposition(l_ligne,l_colonne,l_bouton);
IF (l_ligne>179) and (l_ligne<417-(TextHeight('p')+Z)) and (l_colonne>189) and (l_colonne<471)
 THEN
   BEGIN
    IF l_bouton=1 THEN
     BEGIN
      X1:=l_colonne;
      Y1:=l_ligne;
      CacheCurseur;
      setColor(p_crayon);
      chaine:='';
      REPEAT
       touche :=readkey;
       IF touche <> #13
          THEN
            BEGIN
              IF touche = #08
                 THEN
                   BEGIN
                     SetColor (p_fond);
                     OutTextXY(X1,Y1,chaine);
                     delete(chaine,length(chaine),1);
                     Setcolor (p_crayon);
                     OutTextXY(X1,Y1,chaine);
                   END
                 ELSE
                   BEGIN
                     Chaine := concat(Chaine,touche);
                     IF ((TextWidth(chaine)+X1)<511)
                      THEN OutTextXY (X1,Y1,chaine)
                      ELSE delete(chaine,length(chaine),1);
                   END;
            END;
       UNTIL touche = #13;
      MontreCurseur;
      l_fini:=true;
    END;
   END;
UNTIL l_fini;
SetColor(9);
CacheCurseur;
SetTextStyle(triplexfont,Horizdir,1);
OutTextXY(118,427,'A B C');
MontreCurseur;
SetTextStyle(triplexfont,Horizdir,4);
END;

{****************************************************************************}

PROCEDURE BougeImage1(Xdep,Ydep : INTEGER);
VAR
 P    : POINTER;

BEGIN
GetMem(P,ImageSize(Xdep,Ydep,Xdep+35,Ydep+23));
CacheCurseur;
GetImage(Xdep,Ydep,Xdep+35,Ydep+23,P^);
PutImage(190,136, P^, NormalPut);
MontreCurseur;
FreeMem(P,ImageSize(Xdep,Ydep,Xdep+35,Ydep+23));
END;

{****************************************************************************}

PROCEDURE BougeImage2(Xdep,Ydep : INTEGER);
VAR
  P    : POINTER;

BEGIN
CacheCurseur;
GetMem(P,ImageSize(190,136,225,159));
GetImage(190,136,225,159,P^);
PutImage(Xdep,Ydep,P^, NormalPut);
MontreCurseur;
FreeMem(P,ImageSize(190,136,225,159));
END;

{****************************************************************************}

PROCEDURE SauveZoom;
VAR
   Fichier : FILE;
   P       : POINTER;

BEGIN
GetMem(P,ImageSize(190,180,550,420));
CacheCurseur;
GetImage(190,180,550,420,P^);
MontreCurseur;
Assign (Fichier,'ZOOM.TMP');
Rewrite (Fichier,1);
BlockWrite(fichier,P^,ImageSize(190,180,550,420));
Close (Fichier);
FreeMem(P,ImageSize(190,180,550,420));
END;

{****************************************************************************}

PROCEDURE RappelZoom;
VAR
   Fichier : FILE;
   P       : POINTER;

BEGIN
Assign (Fichier,'ZOOM.TMP');
Reset (Fichier,1);
GetMem(P,Filesize(Fichier));
Blockread(fichier,P^,Filesize(Fichier));
CacheCurseur;
PutImage(190,180,P^,NormalPut);
MontreCurseur;
Freemem(P,Filesize(Fichier));
Close (Fichier);
END;

{****************************************************************************}

PROCEDURE Zoom (VAR p_crayon,p_fond : WORD);
VAR
  Fichier            : FILE;
  l_ligne,l_colonne,
            l_bouton : WORD;
  PointDep,fini      : BOOLEAN;
  P                  : POINTER;
  Size               : LONGINT;
  Xdepart,Ydepart    : INTEGER;
  I,J,Px,Py          : INTEGER;

{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * }

PROCEDURE AffichePoints;
VAR
  I,J      : INTEGER;

BEGIN
FOR J:= 0 TO 23 DO
 FOR I:= 0 TO 35 DO
  BEGIN
   Cachecurseur;
   ColorieRectangle(191+I*10,181+J*10,
                    199+I*10,189+J*10,(Getpixel(190+I,136+J)));
   MontreCurseur;
  END;
END;

{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * }

BEGIN
PointDep:=false;
fini:=false;
Setcolor(12);
SetTextStyle(defaultfont,horizdir,1);
CacheCurseur;
OutTextxy(175,35,'Zoom');
MontreCurseur;
REPEAT
 Trouveposition(l_ligne,l_colonne,l_bouton);
IF (l_ligne>179) and (l_ligne<397) and (l_colonne>189) and (l_colonne<475)
  THEN
   BEGIN
    Size := ImageSize(l_colonne+36,l_ligne+24,l_colonne,l_ligne);
    GetMem(P, Size);
    SetColor(0);
    CacheCurseur;
    GetImage(l_colonne+36,l_ligne+24,l_colonne,l_ligne,P^);
    Rectangle(l_colonne+36,l_ligne+24,l_colonne,l_ligne);
    delay(60);
    PutImage(l_colonne,l_ligne, P^, NormalPut);
    montrecurseur;
    FreeMem(P,Size);
    IF l_bouton=1 THEN
     BEGIN
      Xdepart:=l_colonne;
      Ydepart:=l_ligne;
      PointDep:=true;
     END;
   END;
UNTIL PointDep;
BougeImage1(Xdepart,Ydepart);
SauveZoom;
Setcolor(9);
CacheCurseur;
Rectangle(189,135,227,161);
ColorieRectangle(190,180,550,420,15);
Setcolor(0);
FOR I:= 0 TO 36 DO
   Line(190+I*10,180,190+I*10,420);
FOR J:= 0 TO 24 DO
   Line(190,180+J*10,550,180+J*10);
Affichepoints;
Setcolor(9);
MontreCurseur;
REPEAT
 Trouveposition(l_ligne,l_colonne,l_bouton);
  IF ((l_ligne>180) and (l_ligne<420) and (l_colonne>560) and (l_colonne<680) and (l_bouton=1))
  THEN
    BEGIN
     p_crayon:=getpixel16(l_colonne-1,l_ligne-1);
     cacheCurseur;
     ColorieRectangle(571,441,609,459,p_crayon);
     montreCurseur;
    END;
IF ((l_ligne>180) and (l_ligne<420) and (l_colonne>560) and (l_colonne<680) and (l_bouton=2))
  THEN
    BEGIN
     p_Fond:=getpixel16(l_colonne-1,l_ligne-1);
     cacheCurseur;
     ColorieRectangle(561,461,569,439,p_Fond);
     ColorieRectangle(561,461,619,469,p_Fond);
     ColorieRectangle(561,431,619,439,p_Fond);
     ColorieRectangle(611,461,619,439,p_Fond);
     montreCurseur;
    END;
IF ((l_ligne>179) and (l_ligne<419) and (l_colonne>189) and (l_colonne<549))
 THEN
  BEGIN
  CASE l_bouton OF 1 :
    BEGIN
     Px:=(l_colonne-190)Div(10);
     Py:=(l_ligne-180)Div(10);
     Cachecurseur;
       ColorieRectangle(191+Px*10,181+Py*10,199+Px*10,189+Py*10,p_crayon);
       Putpixel16(190+px,136+py,p_crayon,pRep);
     MontreCurseur;
    END;
                 2 :
    BEGIN
     Px:=(l_colonne-190)Div(10);
     Py:=(l_ligne-180)Div(10);
     Cachecurseur;
       ColorieRectangle(191+Px*10,181+Py*10,199+Px*10,189+Py*10,p_fond);
       Putpixel16(190+px,136+py,p_fond,pRep);
     MontreCurseur;
    END;
   END;
  END;
 IF (l_bouton=1) and (l_ligne>30) and (l_ligne<50) and (l_colonne>180) and (l_colonne<230)
  THEN  fini:=true;
UNTIL fini;
RappelZoom;
BougeImage2(Xdepart,Ydepart);
CacheCurseur;
ColorieRectangle(189,135,227,161,2);
Setcolor(9);
SetTextStyle(defaultfont,horizdir,1);
OutTextxy(175,35,'Zoom');
MontreCurseur;
SetTextStyle(1,0,4);
END;

{****************************************************************************}

PROCEDURE Fichier(VAR l_fini : BOOLEAN; l_fond : WORD);
VAR
 l_ligne,l_colonne,
 l_bouton    : WORD;
 termine     : BOOLEAN;

BEGIN
   termine:=false;
   cachecurseur;
   SetColor(9);
   Rectangle(10,55,80,115);
   ColorieRectangle(11,56,79,114,15);
   SetColor(9);
   SetTextStyle(DefaultFont,Horizdir,1);
   OutTextxy(15,60,'Sauver');
   OutTextxy(15,80,'Quitter');
   OutTextxy(15,100,'Charger');
   MontreCurseur;
   REPEAT
    Trouveposition(l_ligne,l_colonne,l_bouton);
    IF NOT((l_ligne>30) and (l_colonne>12) and (l_ligne<115) and (l_colonne<80)) and (l_bouton=1) OR (l_bouton=2)
      THEN termine:=true;
     IF (l_ligne>80) and (l_colonne>12) and (l_ligne<95) and (l_colonne<80) and (l_bouton=1)
      THEN g_fini:=true;
     IF (l_ligne>60) and (l_colonne>12) and (l_ligne<75) and (l_colonne<80) and (l_bouton=1)
      THEN  BEGIN
             {Sauvegarde(190,180,510,420);} {tout }
             {Sauvegarde(190,180,209,199);}  {20*20}
             Sauvegarde(190,180,337,327); {147*147 }
             termine:=true;
            END;
     IF (l_ligne>100) and (l_colonne>12) and (l_ligne<115) and (l_colonne<80) and (l_bouton=1)
      THEN BEGIN
            Charge;
            termine:=true;
           END;
  UNTIL g_fini OR termine;
  cachecurseur;
  ColorieRectangle(10,55,80,115,2);
  montrecurseur;
  SetTextStyle(TriplexFont,Horizdir,4);
END;

{****************************************************************************}

PROCEDURE Polices(VAR p_police : WORD);
VAR
 P           : POINTER;
 size        : INTEGER;
 l_ligne,l_colonne,
 l_bouton    : WORD;
 termine     : BOOLEAN;

BEGIN
   termine:=false;
   cachecurseur;
   SetColor(9);
   Rectangle(310,55,400,155);
   ColorieRectangle(311,56,399,154,15);
   SetColor(9);
   SetTextStyle(SansSerifFont,Horizdir,1);
   IF p_police=3 THEN setcolor(12);
   OutTextxy(312,55,'SansSerif');
   Setcolor(9);
   SetTextStyle(TriplexFont,Horizdir,1);
   IF p_police=1 THEN setcolor(12);
   OutTextxy(312,75,'Triplex');
   Setcolor(9);
   SetTextStyle(SmallFont,Horizdir,6);
   IF p_police=2 THEN setcolor(12);
   OutTextxy(312,95,'Petite');
   Setcolor(9);
   SetTextStyle(DefaultFont,Horizdir,1);
   IF p_police=0 THEN setcolor(12);
   OutTextxy(312,115,'Defaut');
   Setcolor(9);
   SetTextStyle(GothicFont,Horizdir,2);
   IF p_police=4 THEN setcolor(12);
   OutTextxy(312,125,'Gothic');
   MontreCurseur;
   REPEAT
    Trouveposition(l_ligne,l_colonne,l_bouton);
    IF NOT((l_ligne>30) and (l_colonne>312) and (l_ligne<155) and (l_colonne<400)) and (l_bouton=1) OR (l_bouton=2)
      THEN termine:=true;
    IF (l_ligne>55) and (l_colonne>312) and (l_ligne<75) and (l_colonne<400) and (l_bouton=1)
      THEN BEGIN
            p_police:=SansSerifFont;
            termine:=true;
           END;
     IF (l_ligne>75) and (l_colonne>312) and (l_ligne<95) and (l_colonne<400) and (l_bouton=1)
      THEN  BEGIN
             p_police:=TriplexFont;
             termine:=true;
            END;
     IF (l_ligne>95) and (l_colonne>312) and (l_ligne<115) and (l_colonne<400) and (l_bouton=1)
      THEN BEGIN
            p_police:=SmallFont;
            termine:=true;
           END;
     IF (l_ligne>115) and (l_colonne>312) and (l_ligne<125) and (l_colonne<400) and (l_bouton=1)
      THEN BEGIN
            p_police:=DefaultFont;
            termine:=true;
           END;
     IF (l_ligne>125) and (l_colonne>312) and (l_ligne<155) and (l_colonne<400) and (l_bouton=1)
      THEN BEGIN
            p_police:=GothicFont;
            termine:=true;
           END;
  UNTIL termine;
CacheCurseur;
ColorieRectangle(310,55,400,155,2);
montrecurseur;
END;

{****************************************************************************}

PROCEDURE Edit(VAR p_PressPapier : POINTER;
               VAR pp_size,l_lar,l_long  : INTEGER);
VAR
 l_ligne,l_colonne,
 l_bouton    : WORD;
 termine     : BOOLEAN;


{ * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *} 

PROCEDURE CoupeImage(VAR lar,long,p_Xdep,p_Ydep : INTEGER );
VAR
 l_ligne,l_colonne,l_ligne1,l_colonne1
 ,l_bouton         : WORD;
 x1,y1,x3,y3,
 CoefL,CoefC       : INTEGER;
 x,y               : INTEGER;
 point1,fini       : BOOLEAN;
 P                 : POINTER;
 Size              : WORD;

BEGIN
point1:=false;
fini:=false;
ColorieRectangle(280,445,380,470,15);
Setcolor(9);
Rectangle(280,445,380,470);
SetTextStyle(smallfont,horizdir,6);
OutTextxy(285,450,'X:');
OutTextxy(335,450,'Y:');
MontreCurseur;
l_colonne1:=190;
l_ligne1:=180;
REPEAT
Trouveposition(l_ligne,l_colonne,l_bouton);
  IF (l_ligne>179) and (l_ligne<421) and (l_colonne>189) and (l_colonne<511)
  THEN
   BEGIN
   Coordonnees(l_ligne,l_colonne,l_ligne1,l_colonne1);
    IF (l_bouton=1)
     THEN
      BEGIN
       X1:= l_colonne;
       Y1:= l_ligne;
       point1:=true;
      END;
   END;
UNTIL point1=true;
REPEAT
   Trouveposition(l_ligne,l_colonne,l_bouton);
   IF (l_ligne>179) and (l_ligne<421) and (l_colonne>189) and (l_colonne<511)
    THEN
      BEGIN
        IF l_colonne>=X1
         THEN
          IF l_ligne>=Y1
           THEN
            BEGIN
             X3:=X1-1;
             Y3:=Y1-1;
             CoefL:=-1;
             CoefC:=-1;
            END
           ELSE
            BEGIN
             X3:=X1-1;
             Y3:=l_ligne-1;
             CoefL:=1;
             CoefC:=-1;
           END
         ELSE
          IF l_ligne>=Y1
           THEN
            BEGIN
             X3:=l_colonne-1;
             Y3:=Y1-1;
             CoefL:=-1;
             CoefC:=1;
            END
          ELSE
           BEGIN
            X3:=l_colonne-1;
            Y3:=l_ligne-1;
            CoefL:=1;
            CoefC:=1;
           END;
        Size := ImageSize(X1+CoefC,Y1+CoefL,l_colonne-CoefC,l_ligne-CoefL);
        GetMem(P, Size);
        SetColor(0);
        CacheCurseur;
        GetImage(X1+CoefC,Y1+CoefL,l_colonne-CoefC,l_ligne-CoefL,P^);
        Rectangle(X1,y1,l_colonne,l_ligne);
        delay(60);
        PutImage(X3,Y3, P^, NormalPut);
        montrecurseur;
        FreeMem(p,Size);
        Coordonnees(l_ligne,l_colonne,l_ligne1,l_colonne1);
        IF l_bouton=2 THEN
         BEGIN
          lar:=abs(x1-l_colonne);
          long:=abs(y1-l_ligne);
          fini:=true;
          X:=X3;
          Y:=Y3;
          p_Xdep:=X-229;
          p_Ydep:=Y-139;
          ColorieRectangle(280,445,380,470,2);
        END;
    END;
UNTIL fini;
END;

{ * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *} 

PROCEDURE Copier(VAR p_termine : BOOLEAN ;VAR P : POINTER;
                 VAR p_Size : INTEGER; VAR X3,Y3 : INTEGER);
VAR
   Xdep,Ydep,
   X2,Y2       : INTEGER;
   X1dep,Y1dep : INTEGER;

BEGIN
IF (p_size<>0) THEN FreeMem(p,p_Size);
 CoupeImage(X2,Y2,Xdep,Ydep);
 X1dep:=Xdep+230;
 Y1dep:=Ydep+140;
 Setcolor(0);
 X3:=X2+X1dep;
 Y3:=Y2+Y1dep;
 p_Size:=ImageSize(X1dep,Y1dep,X3,Y3);
 GetMem(P, p_Size);
 CacheCurseur;
 GetImage(X1dep,Y1dep,X3,Y3,P^);
 MontreCurseur;
 X3:=X3-X1dep;
 Y3:=Y3-Y1dep;
 p_termine:=true;
END;

{ * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *} 

PROCEDURE Coller(VAR p_termine : BOOLEAN; VAR p_P : POINTER; VAR l_Size : INTEGER;
                 VAR lar,long : INTEGER);
VAR
   size                       : INTEGER;
   l_ligne,l_colonne,l_bouton : WORD;
   p                          : POINTER;

BEGIN
IF l_size=0
 THEN termine:=true
 ELSE
  BEGIN
   REPEAT
    Trouveposition(l_ligne,l_colonne,l_bouton);
    IF (l_ligne>179) and (l_ligne<421-long) and (l_colonne>189) and (l_colonne<511-lar)
     THEN
      BEGIN
       Size:=ImageSize(l_colonne+lar,l_ligne+long,l_colonne,l_ligne);
       GetMem(P, Size);
       SetColor(0);
       CacheCurseur;
       GetImage(l_colonne+lar,l_ligne+long,l_colonne,l_ligne,P^);
       PutImage(l_colonne,l_ligne,p_P^, NormalPut);
       Delay(40);
       PutImage(l_colonne,l_ligne, P^, NormalPut);
       montrecurseur;
       FreeMem(p,Size);
        IF l_bouton=2 THEN
         BEGIN
          CacheCurseur;
          PutImage(l_colonne,l_ligne,p_P^, NormalPut);
          montrecurseur;
          termine:=true;
         END;
     END;
  UNTIL Termine;
 END;
END;

{ * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *} 

PROCEDURE CopierVers(VAR p_termine : BOOLEAN);
VAR
   I,J          : BYTE;
   Xmax,Ymax,
   Xdep,Ydep    : INTEGER;

BEGIN
CoupeImage(Xmax,Ymax,Xdep,Ydep);
Xdep:=xdep+229;
Ydep:=Ydep+139;
Sauvegarde(xdep,ydep,xdep+xmax,ydep+ymax);
p_termine:=true;
END;

{ * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *} 

PROCEDURE Importer;
VAR
   l_image            : t_image;
   fichier            : FILE ;
   chaine             : Chaine50;
   nomfichier         : Chaine11;
   Fch                : STRING;
   touche             : CHAR;
   Xmax,Ymax          : BYTE;
   code,size          : WORD;
   fini               : BOOLEAN;
   l_colonne,l_ligne,
             l_bouton : WORD;
   P                  : POINTER;

BEGIN
  fini:=false;
  Setcolor(9);
  SetTextStyle(DefaultFont,Horizdir,1);
  CacheCurseur;
  ColorieRectangle(95,75,465,120,15);
  Setcolor(9);
  Rectangle(95,75,465,120);
  OutTextXY (100,80,'Donnez le nom du fichier a charger : ');
  chaine:='';
  ReadStringXY (390,80,chaine,9,15);
  Nomfichier := copy (chaine,1,11);
  {$I-}
  Assign (Fichier,nomfichier+'.IMA');
  RESET(Fichier);
  {$I+}
  IF IORESULT <> 0
    THEN
       BEGIN
         Fch:='le fichier .IMA est introuvable';
         Insert(NomFichier,Fch,12);
         OutTextxy(100,100,Fch);
         touche:=readkey;
         colorieRectangle(95,75,465,120,2);
         MontreCurseur;
       END
    ELSE
     BEGIN
      Blockread(fichier,l_image,sizeof(l_image),code);
      Close (Fichier);
      Xmax:=l_image[1];
      Ymax:=l_image[2];
      colorieRectangle(95,75,465,120,2);
      MontreCurseur;
      REPEAT
      Trouveposition(l_ligne,l_colonne,l_bouton);
      IF (l_ligne>179) and (l_ligne<421-Ymax) and (l_colonne>189) and (l_colonne<511-Xmax)
        THEN
         BEGIN
          Size := ImageSize(l_colonne+Xmax,l_ligne+Ymax,l_colonne,l_ligne);
          GetMem(P, Size);
          SetColor(0);
          CacheCurseur;
          GetImage(l_colonne,l_ligne,l_colonne+Xmax,l_ligne+Ymax,P^);
          Rectangle(l_colonne,l_ligne,l_colonne+Xmax,l_ligne+Ymax);
          AfficheMatrice(l_colonne-1,l_ligne-1,l_image);
          Putimage(l_colonne,l_ligne,p^,NormalPut);
          montrecurseur;
          FreeMem(P,Size);
          IF l_bouton=1 THEN
           BEGIN
            AfficheMatrice(l_colonne-1,l_ligne-1,l_image);
            fini:=true;
           END;
         END;
      UNTIL fini;
      END;
END;

{ * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *} 

BEGIN{ *** Edit ***  }
   termine:=false;
   CacheCurseur;
   SetColor(9);
   Rectangle(240,55,340,135);
   ColorieRectangle(241,56,339,134,15);
   SetColor(9);
   SetTextStyle(DefaultFont,Horizdir,1);
   OutTextxy(245,60,'Copier Vers');
   OutTextxy(245,80,'Coller');
   OutTextxy(245,100,'Copier');
   OutTextxy(245,120,'Importer');
   MontreCurseur;
   REPEAT
    Trouveposition(l_ligne,l_colonne,l_bouton);
    IF NOT((l_ligne>30) and (l_colonne>240) and (l_ligne<135) and (l_colonne<340)) and ((l_bouton=1) OR (l_bouton=2))
      THEN BEGIN
            termine:=true;
            CacheCurseur;
            ColorieRectangle(240,55,340,135,2);
            montrecurseur;
           END;
     IF (l_ligne>75) and (l_colonne>240) and (l_ligne<95) and (l_colonne<340) and (l_bouton=1)      THEN BEGIN
            CacheCurseur;
            ColorieRectangle(240,55,340,135,2);
            montrecurseur;
            coller(termine,p_pressPapier,pp_size,l_lar,l_long);
           END;
     IF (l_ligne>55) and (l_colonne>240) and (l_ligne<75) and (l_colonne<340) and (l_bouton=1)
      THEN  BEGIN
            CacheCurseur;
            ColorieRectangle(240,55,340,135,2);
            montrecurseur;
            CopierVers(termine);
            END;
     IF (l_ligne>95) and (l_colonne>240) and (l_ligne<115) and (l_colonne<340) and (l_bouton=1)
      THEN BEGIN
            termine:=true;
            CacheCurseur;
            ColorieRectangle(240,55,340,135,2);
            montrecurseur;
            copier(termine,p_pressPapier,pp_size,l_lar,l_long);
           END;
    IF (l_ligne>115) and (l_colonne>240) and (l_ligne<135) and (l_colonne<340) and (l_bouton=1)
      THEN BEGIN
            termine:=true;
            CacheCurseur;
            ColorieRectangle(240,55,340,135,2);
            montrecurseur;
            Importer;
           END;
  UNTIL termine;
  SetTextStyle(1,0,4);
END;

{****************************************************************************}

PROCEDURE Taille(VAR p_taille : INTEGER);
VAR
    mot  : Chaine50;
    code : INTEGER;

BEGIN
 Cachecurseur;
 ColorieRectangle(425,75,630,95,15);
 Setcolor(9);
 Rectangle(425,75,630,95);
 SetTextStyle(DefaultFont,0,1);
 OutTextXY(430,80,'Donnez la taille :');
 str(p_taille,mot);
 ReadStringXY(575,80,mot,9,15);
 VAL(mot,p_taille,code);
 ColorieRectangle(425,75,630,95,2);
 Montrecurseur;
END;

{****************************************************************************}

PROCEDURE Image;


{ * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}

FUNCTION Point(x : INTEGER; Position : INTEGER) : WORD;
BEGIN
IF ODD(Position) THEN X:=X*2+271
                 ELSE X:=X*2+272;
Point:=Getpixel(X,239+position);
END;

{ * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}

PROCEDURE TourneAdroite;
VAR
  I,J,K,Jmax : INTEGER;
  Pas,Marche : REAL;
  Pos        : INTEGER;
  New        : WORD;

BEGIN
I:=80;
REPEAT
   FOR K:= 0 TO 1 DO
    BEGIN
    Jmax:=240-(80-I+(K+20-(I DIV 4))*2);
    Pos:=1;
    Pas:=(120/(Jmax-120));
    Marche:=Pas;
    FOR J:= 1 TO Jmax DO
     BEGIN
      Marche:=marche-1;
      IF (marche) >=0
       THEN
        BEGIN
         New:=point(I-K-1,Pos);
         INC(Pos);
        END
         ELSE Marche:=Marche+pas+1;
      PutPixel16(430+I-k,259-I+K+J-(20-(I DIV 4)),New,pRep);
     END;
   END;
   Jmax:=240-(80-I+(20+2-(I DIV 4))*2);
   FOR K:= 2 TO 3 DO
    BEGIN
    Pos:=1;
    Pas:=(120/(Jmax-120));
    Marche:=Pas;
     FOR J:= 1 TO Jmax DO
      BEGIN
       marche:=marche-1;
       IF (marche) >=0
        THEN
         BEGIN
          New:=point(I-K-1,Pos);
          INC(Pos);
         END
          ELSE Marche:=Marche+pas+1;
     PutPixel16(430+I-k,259-I+2+J-(20-(I DIV 4)),New,pRep);
    END;
   END;
I:=I-4;
UNTIL I=0;
END;

{ * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}

PROCEDURE TourneAgauche;
VAR
  I,J,K,Jmax : INTEGER;
  Pas,Marche : REAL;
  Pos        : INTEGER;
  New        : WORD;

BEGIN
I:=0;
REPEAT
   FOR K:= 0 TO 1 DO
    BEGIN
    Jmax:=240-((I+K-(I DIV 4))*2);
    Pos:=1;
    Pas:=(120/(Jmax-120));
    Marche:=Pas;
    FOR J:= 1 TO Jmax DO
     BEGIN
      Marche:=marche-1;
      IF (marche) >=0
       THEN
        BEGIN
         New:=point(I+K,Pos);
         INC(Pos);
        END
         ELSE Marche:=Marche+pas+1;
      PutPixel16(190+I+k,179+J+K+I-(I DIV 4),New,pRep);
     END;
   END;
   Jmax:=240-((I+2-(I DIV 4))*2);
   FOR K:= 2 TO 3 DO
    BEGIN
    Pos:=1;
    Pas:=(120/(Jmax-120));
    Marche:=Pas;
     FOR J:= 1 TO Jmax DO
      BEGIN
       marche:=marche-1;
       IF (marche) >=0
        THEN
         BEGIN
          New:=point(I+K,Pos);
          INC(Pos);
         END
          ELSE Marche:=Marche+pas+1;
      PutPixel16(190+I+K,179+J+2+I-(I DIV 4),New,pRep);
    END;
   END; 
I:=I+4;
UNTIL I=80;
END;

{ * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}

BEGIN
CacheCurseur;
TourneAdroite;
TourneAgauche;
MontreCurseur;
END;

{****************************************************************************}
{****************************************************************************}

BEGIN
 InitGraphiques;
 cleardevice;
 DessinefontEcran;
 IF paramcount=1
  THEN
   BEGIN
     {$I-}
     ch:=paramstr(1);
     Assign (g_Fichier,ch);
     RESET(g_Fichier,1);
     {$I+}
        IF IORESULT <> 0
          THEN
             BEGIN
              Closegraph;
              writeln('ce fichier n''existe pas dans ce rpertoire');
              writeln('ou vous n''avez pas spcifier l''extention .ECR');
              Halt(1);
             END
          ELSE
           BEGIN
            GetMem(g_image,Filesize(g_Fichier));
            Blockread(g_fichier,g_image^,Filesize(g_Fichier));
            PutImage(190,180,g_image^,NormalPut);
            Freemem(g_image,Filesize(g_Fichier));
            Close (g_Fichier);
          END;
   END;
 InitSouris;
 crayon:=15;
 fond:=15;
 g_fini:=false;
 g_ppSize:=0;
 g_police:=DefaultFont;
 g_taille:=1;
REPEAT
 Trouveposition(ligne,colonne,bouton);
 IF crayon=17 THEN BEGIN
                    crayon:=fond;
                    ColorieRectangle(571,441,609,459,crayon);
                   END;
 IF ((ligne>180) and (ligne<420) and (colonne>560) and (colonne<680) and (bouton=1))
  THEN
    BEGIN
     crayon:=getpixel16(colonne-1,ligne-1);
     cacheCurseur;
     ColorieRectangle(571,441,609,459,crayon);
     montreCurseur;
    END;
IF ((ligne>180) and (ligne<420) and (colonne>560) and (colonne<680) and (bouton=2))
  THEN
    BEGIN
     Fond:=getpixel16(colonne-1,ligne-1);
     cacheCurseur;
     ColorieRectangle(561,461,569,439,Fond);
     ColorieRectangle(561,461,619,469,Fond);
     ColorieRectangle(561,431,619,439,Fond);
     ColorieRectangle(611,461,619,439,Fond);
     Rectangle(189,179,511,421);
     montreCurseur;
    END;
 IF (bouton=1) and (ligne>140) and (ligne<220) and (colonne>100) and (colonne<180)
   THEN BEGIN
         traceligne(crayon);
        END;
 IF (bouton=1) and (ligne>140) and (ligne<220) and (colonne>20) and (colonne<100)
  THEN BEGIN
        delay(80);
        Pinceau(crayon);
       END;
 IF (bouton=1) and (ligne>220) and (ligne<300) and (colonne>20) and (colonne<100)
  THEN BEGIN
         TraceRectangle(crayon,1);
       END;
 IF (bouton=1) and (ligne>220) and (ligne<300) and (colonne>100) and (colonne<180)
  THEN BEGIN
         Cercle(crayon,1);
       END;
 IF (bouton=1) and (ligne>300) and (ligne<380) and (colonne>20) and (colonne<100)
  THEN BEGIN
         TraceRectangle(crayon,2);
       END;
 IF (bouton=1) and (ligne>300) and (ligne<380) and (colonne>100) and (colonne<180)
  THEN BEGIN
         Cercle(crayon,2);
       END;
 IF (bouton=1) and (ligne>380) and (ligne<460) and (colonne>20) and (colonne<100)
  THEN BEGIN
         Peinture(crayon,fond);
       END;
 IF (bouton=1) and (ligne>380) and (ligne<420) and (colonne>100) and (colonne<180)
  THEN BEGIN
         Gomme(fond);
       END;
 IF (bouton=1) and (ligne>420) and (ligne<460) and (colonne>100) and (colonne<180)
  THEN BEGIN
         Texte(crayon,fond,g_police,g_taille);
       END;
 IF (bouton=1) and (ligne>30) and (ligne<50) and (colonne>380) and (colonne<430)
  THEN BEGIN
         Image;
       END;
 IF (bouton=1) and (ligne>30) and (ligne<50) and (colonne>170) and (colonne<230)
  THEN Zoom(crayon,fond);
IF (bouton=1) and (ligne>30) and (ligne<50) and (colonne>310) and (colonne<360)
 THEN Polices(g_police);
IF (bouton=1) and (ligne>30) and (ligne<50) and (colonne>10) and (colonne<70)
 THEN  fichier(g_fini,fond);
IF (bouton=1) and (ligne>30) and (ligne<50) and (colonne>85) and (colonne<150)
 THEN  BEGIN
         {EffaceTout}
         CacheCurseur;
         ColorieRectangle(189,179,511,421,fond);
         MontreCurseur;
       END;
IF (bouton=1) and (ligne>30) and (ligne<50) and (colonne>240) and (colonne<300)
 THEN  Edit(g_pressPapier,g_ppSize,g_lar,g_long);
IF (bouton=1) and (ligne>30) and (ligne<50) and (colonne>450) and (colonne<510)
 THEN  Taille(g_Taille);
UNTIL g_fini;
CloseGraph;
END.